# coding: utf-8


"""
IGNORE:
    Nutanix Clustermgmt Versioned APIs

    Manage Hosts, Clusters and other Infrastructure.  # noqa: E501

    OpenAPI spec version: 4.0.1-beta-2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.IpmiReference import IpmiReference  # noqa: F401,E501
from ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress import IPAddress  # noqa: F401,E501

class ControllerVmReference(object):

    """Host entity with its attributes.

    :param id: (:attr:`id`) Controller VM Id.
    :type id: 
    :param external_address: (:attr:`external_address`) 
    :type external_address: 
    :param backplane_address: (:attr:`backplane_address`) 
    :type backplane_address: 
    :param rdma_backplane_address: (:attr:`rdma_backplane_address`) RDMA backplane address.
    :type rdma_backplane_address: 
    :param ipmi: (:attr:`ipmi`) 
    :type ipmi: 
    :param nat_ip: (:attr:`nat_ip`) 
    :type nat_ip: 
    :param nat_port: (:attr:`nat_port`) NAT port.
    :type nat_port: 
    :param maintenance_mode: (:attr:`maintenance_mode`) Maintenance mode status.
    :type maintenance_mode: 
    :param rackable_unit_uuid: (:attr:`rackable_unit_uuid`) Rackable unit UUID.
    :type rackable_unit_uuid: 

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'id': 'int',
        'external_address': 'common.v1.config.IPAddress',
        'backplane_address': 'common.v1.config.IPAddress',
        'rdma_backplane_address': 'list[common.v1.config.IPAddress]',
        'ipmi': 'clustermgmt.v4.config.IpmiReference',
        'nat_ip': 'common.v1.config.IPAddress',
        'nat_port': 'int',
        'maintenance_mode': 'bool',
        'rackable_unit_uuid': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'id': 'id',
        'external_address': 'externalAddress',
        'backplane_address': 'backplaneAddress',
        'rdma_backplane_address': 'rdmaBackplaneAddress',
        'ipmi': 'ipmi',
        'nat_ip': 'natIp',
        'nat_port': 'natPort',
        'maintenance_mode': 'maintenanceMode',
        'rackable_unit_uuid': 'rackableUnitUuid',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, id=None, external_address=None, backplane_address=None, rdma_backplane_address=None, ipmi=None, nat_ip=None, nat_port=None, maintenance_mode=None, rackable_unit_uuid=None, *args, **kwargs):  # noqa: E501
        self.__id = None
        self.__external_address = None
        self.__backplane_address = None
        self.__rdma_backplane_address = None
        self.__ipmi = None
        self.__nat_ip = None
        self.__nat_port = None
        self.__maintenance_mode = None
        self.__rackable_unit_uuid = None
        self.discriminator = None
        if id is not None:
            self.__id = id
        if external_address is not None:
            self.__external_address = external_address
        if backplane_address is not None:
            self.__backplane_address = backplane_address
        if rdma_backplane_address is not None:
            self.__rdma_backplane_address = rdma_backplane_address
        if ipmi is not None:
            self.__ipmi = ipmi
        if nat_ip is not None:
            self.__nat_ip = nat_ip
        if nat_port is not None:
            self.__nat_port = nat_port
        if maintenance_mode is not None:
            self.__maintenance_mode = maintenance_mode
        if rackable_unit_uuid is not None:
            self.__rackable_unit_uuid = rackable_unit_uuid
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'clustermgmt.v4.config.ControllerVmReference'

    def _initialize_object_version(self):
        return 'v4.r0.b2'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def id(self):
        """
        Controller VM Id.

        :type:

                :class:`~int`
        """  # noqa: E501
        return self.__id

    @id.setter
    def id(self, id):

        self.__id = id

    @property
    def external_address(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__external_address

    @external_address.setter
    def external_address(self, external_address):

        self.__external_address = external_address

    @property
    def backplane_address(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__backplane_address

    @backplane_address.setter
    def backplane_address(self, backplane_address):

        self.__backplane_address = backplane_address

    @property
    def rdma_backplane_address(self):
        """
        RDMA backplane address.

        :type:
             list[ :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress` ]
        """  # noqa: E501
        return self.__rdma_backplane_address

    @rdma_backplane_address.setter
    def rdma_backplane_address(self, rdma_backplane_address):

        self.__rdma_backplane_address = rdma_backplane_address

    @property
    def ipmi(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.clustermgmt.v4.config.IpmiReference`
        """  # noqa: E501
        return self.__ipmi

    @ipmi.setter
    def ipmi(self, ipmi):

        self.__ipmi = ipmi

    @property
    def nat_ip(self):
        """
        

        :type:
            :class:`~ntnx_clustermgmt_py_client.models.common.v1.config.IPAddress`
        """  # noqa: E501
        return self.__nat_ip

    @nat_ip.setter
    def nat_ip(self, nat_ip):

        self.__nat_ip = nat_ip

    @property
    def nat_port(self):
        """
        NAT port.

        :type:

                :class:`~int`
        """  # noqa: E501
        return self.__nat_port

    @nat_port.setter
    def nat_port(self, nat_port):

        self.__nat_port = nat_port

    @property
    def maintenance_mode(self):
        """
        Maintenance mode status.

        :type:

                :class:`~bool`
        """  # noqa: E501
        return self.__maintenance_mode

    @maintenance_mode.setter
    def maintenance_mode(self, maintenance_mode):

        self.__maintenance_mode = maintenance_mode

    @property
    def rackable_unit_uuid(self):
        """
        Rackable unit UUID.

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__rackable_unit_uuid

    @rackable_unit_uuid.setter
    def rackable_unit_uuid(self, rackable_unit_uuid):
        if rackable_unit_uuid is not None and not re.search('^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$', rackable_unit_uuid):  # noqa: E501
            raise ValueError(r"Invalid value for `rackable_unit_uuid`, must be a follow pattern or equal to `/^[a-fA-F0-9]{8}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{4}-[a-fA-F0-9]{12}$/`")  # noqa: E501

        self.__rackable_unit_uuid = rackable_unit_uuid

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:

                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):
        
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(ControllerVmReference, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ControllerVmReference):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

